/* $Id: ConnectionPool.java,v 3.1 2001/11/06 04:00:15 886014 Rel $
 * Copyright (c) 2001 TSUTSUMI Kikuo. ALL RIGHTS RESERVED.
 */
package connectionpool;

import java.sql.SQLException;
import java.util.LinkedList;

/**
 * <P>̃NX͐ڑۑ邽߂̃v[Ǘ܂Bv[ɂ2
 * ނ܂BvO DriverManager.getConnection() Ŏ擾
 * gp̐ڑۑv[BсAvO 
 * Connection.close() ĂяoĖgpɂȂڑۑv[
 * B</P>
 *
 * <P>̐ڑv[NXɒǉڑIuWFNǵA 
 * getConnection() \bhɂăvOvꂽڑłB
 * āAgp̃v[ activePool ɕۑ܂B</P>
 *
 * <P>Connection.close()ŖgpɂȂڑIuWFNǵA 
 * {@link #release(PoolingConnection) release()}ĂяoāAgpv[
 * 疢gpv[ stockPool Ɉړ܂B</P>
 *
 * @author TSUTSUMI Kikuo
 * @version $Revision: 3.1 $
 **/
class ConnectionPool
{
  /** gpĂȂڑ̃v[(L[\ƂĎgp) */
  private LinkedList stockPool;
  /** gp̐ڑ̃v[(AXg) */
  private LinkedList activePool;
  /**
   * <P>gpڑi[v[ƁAgp̐ڑi[v[
   * ܂B</P>
   **/
  public ConnectionPool ()
  {
    stockPool = new LinkedList ();
    activePool = new LinkedList ();
  }
  /** <P>ڑv[Ŝ݂̌̃TCYԂ܂B</P>
   * @return gpڑv[̃TCYƖgpڑv[̃TCY̍vB
   **/
  public int size () { return stockPool.size () + activePool.size (); }
  /**
   * <P>w肳ꂽڑgp̏Ԃɐݒ肵āAgpv[ɒǉ
   * Bڑ폜Ƃɂ͐擪猟Ă߁A擪ɒǉ
   * ܂B́Aŋ߂Ɏgpڑɍ폜ł낤Ɛ肵
   * ߂łB</P>
   * @param conn ǉڑIuWFNgB
   **/
  public synchronized void add (PoolingConnection conn)
  { activePool.addFirst (conn.activate ()); }
  /**
   * <P>gpڑv[ŏɕۑꂽڑԂ܂BԂڑ
   * gpڑv[菜܂B</P>
   * @return gpĂȂڑIuWFNgB
   **/
  public synchronized PoolingConnection get ()
  { return (PoolingConnection)stockPool.removeLast (); }
  /**
   * <P>gpڑv[Ăΐ^Ԃ܂B</P>
   * @return gpڑ݂ΐ^B
   **/
  public boolean hasStockConnection () { return !stockPool.isEmpty (); }
  /**
   * <P>gp̐ڑAgpv[疢gpv[Ɉړ܂B</P>
   *
   * @param conn gpԂɂv[OڑIuWFNgB
   **/
  synchronized void release (PoolingConnection conn)
  {
    activePool.remove (conn);
    stockPool.addFirst (conn);
  }
  /**
   * <P>ڑڑv[폜܂B̃\bhĂԑOɁA
   * PoolingConnection.closeConnection ()sĂȂ΂Ȃ
   * B</P>
   *
   * @param conn ڑv[폜v[OڑIuWFNgB
   **/
  synchronized void remove (PoolingConnection conn)
  {
    // ̃\bhĂԏꍇAڑ͎gpł\Ǝv
    // 邽߁AactivePool Ɍ
    if (!activePool.remove (conn))
      stockPool.remove (conn);
  }
  /**
   * <P>gpڑIuWFNgׂĔj܂B</P>
   *
   * @throws SQLException ڑ̐ؒfɎsꍇB
   **/
  synchronized void clear ()
    throws SQLException
  {
    if (stockPool != null)
      {
	PoolingConnection conn;
	while (!stockPool.isEmpty ())
	  {
	    conn = (PoolingConnection)stockPool.removeFirst ();
	    conn.closeConnection ();
	  }
      }
  }
  /**
   * <P>ڑv[j܂B̃Xbhڑv[gp
   * ꍇÃ\bhĂяoƁÃXbhڑv[g
   * płȂȂ̂ŒӂĂB</P>
   *
   * @throws SQLException ڑ̐ؒfɎsꍇB
   **/
  synchronized void destroy ()
    throws SQLException
  {
    /*
     * gpڑv[j
     */
    if (stockPool != null)
      {
	PoolingConnection conn;
	while (!stockPool.isEmpty ())
	  {
	    conn = (PoolingConnection)stockPool.removeFirst ();
	    conn.closeConnection ();
	  }
	stockPool = null;
      }
    /*
     * gpڑv[j
     */
    if (activePool != null)
      {
	PoolingConnection conn;
	while (!activePool.isEmpty ())
	  {
	    conn = (PoolingConnection)activePool.removeFirst ();
	    conn.closeConnection ();
	  }
	activePool = null;
      }
  }
}

/*
 * Local Variables: ***
 * compile-command: "(cd ../../; ant -emacs compile)" ***
 * End: ***
 */
