/* $Id: ConnectionPoolDriver.java,v 3.2 2001/11/06 07:56:09 886014 Rel $
 * Copyright (c) 2001 TSUTSUMI Kikuo. ALL RIGHTS RESERVED.
 */
package connectionpool;

import java.sql.*;
import java.util.Properties;
import java.util.HashMap;
import java.util.ResourceBundle;
import java.util.Iterator;
import java.util.Enumeration;
import java.util.Map;

/**
 * <P>̃NXJDBCڑǗėp邽߂́A[IJDBChC
 * oNXłB</P>
 *
 * <P>f[^x[XƂ̐ڑ̓I[o[wbh傫AȂ̎Ԃ
 * Ă܂܂BŐڑ̃v[AgpȂȂڑؒf
 * Ƀv[ɕۑĂāAōėpł悤ɂ܂Bۑ
 * ꏊڑv[AۑĂƂڑv[OƌĂԂƂɂ
 * ܂B</P>
 *
 * <P>A̐ڑ𒷂g邱Ƃ̂Ȃ悤ɁA莞Ԏgp
 * ĂȂڑA񐔎gpꂽڑ͐ؒf悤ɂĂ
 * Bꂼ̎ԁE񐔂͐ݒt@CŎw肵܂BftHgł 
 * 5 b 5 ł(see: {@link #timeout timeout}, {@link #maxUse
 * maxUse})B</P>
 *
 * <P>̃NX͒ʏ JDBC hCoƓl̎gł悤Ɏ
 * Ă܂B܂A<code>java.lang.Class.forName()</code> Ń[
 * hāA<code>java.sql.DriverManager.getConnection()</code> Őڑ
 * IuWFNg擾ƂgɂȂ܂B</P>
 *
 * <P>ڑڑv[ɕԂɂ́AConnection.close()gp܂B
 * AʏJDBChCo̐ڑIuWFNgƓłB</P>
 *
 * <P>āAڑv[OgpĂȂvOAڑv[
 * Ogp悤ɕύXɂ́AgphCoƐڑ̃f[
 * ^x[XURLύX邾ł(ݒt@C쐬Kv
 * )BvỖWbNύXKv͂܂B</P>
 * 
 * <P>̂悤ȂƂł̂́ADriverManager.getConnection \bh
 * ԂڑIuWFNgAۂ JDBC ڑIuWFNg
 * (java.sql.Connection) 񂾃bp[NXłv[OڑN
 * X {@link connectionpool.PoolingConnection } łBv[
 * OڑIuWFNg java.sql.Connection C^tF[XĂ
 * ܂Bv[OڑIuWFNgɑ΂ČĂяoقƂǂ̃\b
 * h͂̂܂ JDBC ڑIuWFNgɈϏ܂B</P>
 *
 * <P>AConnection.close \bh̓Io[ChĂ邽߁A
 * ۂɂ JDBC ڑPɐؒf̂ł͂܂B{@link
 * connectionpool.PoolingConnection#close() PoolingConnection.close()} 
 * \bhĂ΂ꂽꍇɂ́AڑgpȂȂƂ݂ȂāA
 * v[ɕۑ悤ɂĂ܂B</P>
 *
 * @see connectionpool.PoolingConnection
 * @see connectionpool.PoolingConnection#close()
 *
 * @author TSUTSUMI Kikuo
 * @version $Revision: 3.2 $
 **/
public class ConnectionPoolDriver implements java.sql.Driver
{
  /** ݒt@C̃ftHǵB */
  public final static String CONFIG_FILE = "ConnectionPool";
  /** ڑv[OhCõvgRB */
  public final static String PROTCOL = "jdbc:connectionpool:";
  /** ڑv[OpbP[W̃rWB */
  public final static String REVISION = "Revision: 3.0";
  /** ڑv[Bgp̐ڑIuWFNgƖgp̐ڑIuWFNg
      Ǘ܂B */
  protected static ConnectionPoolDriver connectionPoolDriver;
  /**
   * JDBChCoBݒt@C driverName vpeB̒lݒ肳
   * ܂B
   **/
  protected static String driverName;
  /**
   * JDBChCoNXBݒt@C̃vpeB driverName Ŏw肳
   * ꂽ JDBC hCoIuWFNgQƂ܂B
   **/
  protected static java.sql.Driver driver;
  /**
   * ڑvgRBݒt@C driverName ANZXɎgp
   * vgRłBݒt@C protocol vpeB̒lݒ肳
   * ܂B
   **/
  protected static String protocol;
  /**
   * ڑv[̍őTCYBݒt@C maxPoolSize vpeB̒l
   * ݒ肳܂B1 ȏ̒lw肵܂BA-1 w肳ꂽ
   * ͐ڑv[TCY͖ɂȂ܂BȊO̒lw肳ꂽ
   * ꍇ̓ftHg̒lgp܂BftHg 100 ڑłB
   **/
  protected static int maxPoolSize = 100;
  /**
   * ̐ڑ̍őėp񐔁Bݒt@C maxUse vpeB̒l
   * ݒ肳܂B1 ȏ̒lw肵܂B -1 w肳ꂽꍇ͍
   * p񐔂͖ɂȂ܂BȊO̒lw肳ꂽꍇ̓ftH
   * g̒lgp܂BftHg 5 łB
   **/
  protected static int maxUse = 5;
  /**
   * ڑv[̎gpĂȂڑ̐(ms)Bݒt@C 
   * timeoutSec vpeB̒l 1000 {lݒ肳܂B1 ȏ
   * lw肵܂BA-1 w肳ꂽꍇ͐Ԃ͖ɂ
   * ܂BȊO̒lw肳ꂽꍇ̓ftHg̒lgp܂B
   * ftHg 5 b(5000ms)łB
   **/
  protected static long timeout = 5000;
  /** ANeBuȍőڑBhCõ^f[^ǂݍ݂܂B */
  protected static int maxConnections = -1;
  /** ݒt@CŎw肳ꂽ JDBC ڑƂẮACӂ̕^O
      ђl̃yÃXgłBʏ́AȂƂ "user" vpeB
       "password" vpeB͎w肵Ȃ΂Ȃ܂B */
  protected static Properties jdbcProperties;
  /* ڑv[BڑURLL[ɂĊǗ܂B */
  private HashMap pools = new HashMap ();
  /**
   * X^eBbNubNBNX[hꂽƂɎs܂Bh
   * Co[IuWFNg̍쐬Aݒt@C̓ǂݍ݁AhCo̓o
   * ^AJDBChCo̎QƂs܂B
   **/
  static
  {
    try
      {
	connectionPoolDriver = new ConnectionPoolDriver ();
	connectionPoolDriver.loadProperties (CONFIG_FILE);
	DriverManager.registerDriver (connectionPoolDriver);
	Class.forName (driverName);
	driver = DriverManager.getDriver (protocol);
      }
    catch (ClassNotFoundException e)
      {
	throw new IllegalArgumentException ("ClassNotFound: " +
					    e.getMessage ());
      }
    catch (SQLException e)
      {
	throw new IllegalArgumentException ("SQL: " + e.getMessage () +
					    " (protocol=" + protocol + ")");
      }
  }
  /**
   * <P>̃NX̃IuWFNg̓vOł݂
   * ȂƂۏ؂邽߁ARXgN^Jɂ܂BIuWF
   * Ng̓NX[hꂽƂ static tB[hŐ܂B</P>
   **/
  private ConnectionPoolDriver ()
  {
  }
  /**
   * <P>ڑv[gp\ȐڑoBgp\Ȑڑv[
   * ĂȂ΁Aw肳ꂽ URL Ƀf[^x[Xڑ݂܂Bw
   * 肳ꂽURLɊԈhCoڑ悤ƂĂ邱Ƃ킩
   * ꍇ́Anull Ԃ܂Bf[^x[Xɐڑ݂ꍇAw肳
   * JDBC ڑgpĐڑ܂B</P>
   *
   * @param url f[^x[XڑURLB
   * @param info ڑƂĂ̔Cӂ̕^Oђl̃yÃX
   * gB܂ nullBʏ́AȂƂ "user" vpeB 
   * "password" vpeB͎w肵Ȃ΂ȂȂB
   *
   * @return URLւ̐ڑ\ڑIuWFNgBURL̃vgRF
   * łȂꍇ nullB
   *
   * @throws SQLException f[^x[XANZXG[ꍇB
   **/
  public Connection connect (String url, Properties info)
    throws SQLException
  {
    if (!acceptsURL (url))
      return null;
    return getPoolingConnection (url, info);
  }
  /**
   * <P>w肳ꂽURLɐڑłƔfꍇ true Ԃ܂Bh
   * CóAurlŎw肳ꂽTuvgRFꍇ trueAF
   * łȂꍇ false Ԃ܂B</P>
   *
   * @param url ڑ̃f[^x[XURLB
   * @return w肳ꂽ URL ɃhCoڑłꍇ trueB
   * @throws SQLException f[^x[XANZXG[ꍇB
   **/
  public boolean acceptsURL (String url)
    throws SQLException
  {
    return url.startsWith (PROTCOL);
  }
  /**
   * <P>̋^JDBChCogpJDBChCo(ݒt@CŎw)
   * ̗LȃvpeBɂĂ̏擾܂B</P>
   *
   * @param url ڑ̃f[^x[XURLB
   * @param info ڑI[v̂߂ɑ^O/lyA̐XgB
   * @return \ȃvpeBLq DriverPropertyInfo IuWFN
   * g̔zBvpeBKvȂꍇ́A̔z͋ɂȂ邱Ƃ
   * B
   * @throws SQLException f[^x[XANZXG[ꍇB
   **/
  public DriverPropertyInfo[] getPropertyInfo (String url, Properties info)
    throws SQLException
  {
    String subname = url.substring (PROTCOL.length ());
    String driverUrl = protocol + subname;
    return driver.getPropertyInfo (driverUrl, info);
  }
  /**
   * <P>hCõW[o[W擾܂Bŏ͂̒l 1 
   * Ȃ΂Ȃ܂B</P>
   * @return ̃hCõW[o[WB
   **/
  public int getMajorVersion ()
  {
    String vs = REVISION.substring (REVISION.indexOf (": ") + 2,
				    REVISION.indexOf ('.'));
    return Integer.parseInt (vs);
  }
  /**
   * <P>hCõ}Ci[o[W擾܂Bŏ͂̒l 0 
   * Ȃ΂Ȃ܂B</P>
   * @return ̃hCõ}Ci[o[WB
   **/
  public int getMinorVersion ()
  {
    final int st = REVISION.indexOf ('.') + 1;
    final int dot = REVISION.indexOf ('.', st + 1);
    final int tail = REVISION.length ();
    String vs = REVISION.substring (st, dot >= 0 ? dot : tail);
    return Integer.parseInt (vs);
  }
  /**
   * <P>JDBC^hCogp JDBC hCoAJDBC
   * Compliant<sup>TM</sup> ł邩ǂʒm܂B</P>
   **/
  public boolean jdbcCompliant ()
  {
    return driver.jdbcCompliant ();
  }
  /**
   * JDBChCoBݒt@C driverName vpeB̒lԂ
   * B
   **/
  public static String getDriverName () { return driverName; }
  /**
   * ڑvgRBݒt@C protocol vpeB̒lԂ
   * Bݒt@C driverName Ŏw肳ꂽhCoANZX
   * gpvgRłB
   **/
  public static String getProtocol () { return protocol; }
  /**
   * ڑv[̍őTCYBݒt@C maxPoolSize vpeB̒l
   * Ԃ܂B
   **/
  public static int getMaxPoolSize () { return maxPoolSize; }
  /**
   * ̐ڑ̍őėp񐔁Bݒt@C maxUse vpeB̒l
   * Ԃ܂B
   **/
  public static int getMaxUse () { return maxUse; }
  /**
   * ڑv[̎gpĂȂڑ̐(ms)Bݒt@C 
   * timeoutSec vpeB̒l 1000 {lԂ܂B
   **/
  public static long getTimeout () { return timeout; }
  /**
   * JDBCڑBݒt@CŎw肳ꂽ JDBC ڑƂẮAC
   * ӂ̕^Oђl̃yÃXgԂ܂B
   **/
  public static Properties getJdbcProperties () { return jdbcProperties; }
  /**
   * <P>ڑv[疢gp̐ڑ菜܂B</P>
   *
   * <P>gp̐ڑ́A^C}[IuWFNgɂĐԂĎ
   * Ă܂BāAAvP[Vׂ̂ẴXbhI
   * ĂA^C}[Xbh݂邽߁AAvP[Vɂ
   * IȂꍇ܂B̂悤ȏꍇɂ̃\bhĂԂƁA
   * gpڑׂĔj邽߁A^C}[XbhI邱
   * ł܂B</P>
   * @throws SQLException ڑ̐ؒfɎsꍇB
   **/
  public synchronized static void clear ()
    throws SQLException
  {
    Iterator iter = connectionPoolDriver.pools.values ().iterator ();
    while (iter.hasNext ())
      {
	ConnectionPool pool = (ConnectionPool)iter.next ();
	pool.clear ();
      }
  }
  /**
   * <P>ڑv[j܂B̃Xbhڑv[gp
   * ꍇÃ\bhĂяoƁÃXbhڑv[g
   * płȂȂ̂ŒӁB</P>
   *
   * @throws SQLException ڑ̐ؒfɎsꍇB
   **/
  public synchronized static void destroy ()
    throws SQLException
  {
    Iterator iter = connectionPoolDriver.pools.values ().iterator ();
    while (iter.hasNext ())
      {
	ConnectionPool pool = (ConnectionPool)iter.next ();
	pool.destroy ();
	iter.remove ();
      }
  }
  /**
   * <P>gp\ȐڑoBgp\Ȑڑv[ĂȂ
   * ΁AVڑ쐬B</P>
   *
   * @param url f[^x[XڑURLB
   * @param jp ڑƂẮACӂ̕^Oђl̃yÃX
   * gB܂ nullBʏ́AȂƂ "user" vpeB 
   * "password" vpeB͎w肵Ȃ΂ȂȂB
   *
   * @return v[OڑIuWFNgBڑ̏𒴂ꍇ 
   * nullB
   *
   * @throws SQLException ڑmłȂꍇB
   **/
  private synchronized PoolingConnection getPoolingConnection (String url,
							       Properties jp)
    throws SQLException
  {
    if (url == null || url.equals (""))
      throw new SQLException ("bad url: (null)");
    ConnectionPool pool = (ConnectionPool)pools.get (url);
    if (pool != null)
      {
	while (pool.hasStockConnection ())
	  {
	    PoolingConnection conn = pool.get ();
	    if (conn.isClosed ())
	      {
		/*
		 * ڑ^CAEgȂǂŃN[YĂ΃v[
		 * RlNVB
		 */
		conn.closeConnection ();
	      }
	    else
	      {
		/*
		 * ڑgpڑXgɒǉB
		 */
		pool.add (conn);
		return conn;
	      }
	  }
      }
    return createConnection (pool, url, jp); // ڑ쐬
  }
  /**
   * <P>ڑ쐬܂BۂɃf[^x[XɐڑJDBChCo
   * ԂꂽڑƂɁAv[OڑIuWFNg쐬܂B
   * </P>
   *
   * @param pool ڑǉv[
   * @param url f[^x[XڑURLB
   * @param jp ڑƂẮACӂ̕^Oђl̃yÃX
   * gB܂ nullBʏ́AȂƂ "user" vpeB 
   * "password" vpeB͎w肵Ȃ΂ȂȂB
   *
   * @return ڑIuWFNgB
   *
   * @throws SQLException ڑmłȂꍇB܂̓f[^x[
   * Xւ̃ANZXɎsꍇB܂́Aڑl𒴂ꍇB
   **/
  private synchronized PoolingConnection createConnection (ConnectionPool pool,
							   String url,
							   Properties jp)
    throws SQLException
  {
    if (pool == null)
      {
	pool = new ConnectionPool ();
	pools.put (url, pool);
      }
    final int size = pool.size ();
    if (maxPoolSize > -1 && size >= maxPoolSize)
      throw new SQLException ("max connection (" + maxPoolSize + ") exceeded");
    Connection jconn = null;
    try
      {
	String subname = url.substring (PROTCOL.length ());
	String driverUrl = protocol + subname;
	jconn = ConnectionPoolDriver.driver.connect (driverUrl, jp);
      }
    catch (SQLException e)
      {
	throw new SQLException (e.getMessage () + " (URL=" + url + ")");
      }
    PoolingConnection conn = new PoolingConnection (pool, jconn);
    pool.add (conn);
    /*
     * ŏ̐ڑ쐬łAANeBuȐڑ̍ő吔܂hCo
     * ₢킹ĂȂꍇAő吔₢킹
     */
    if (size == 0 && maxConnections < 0)
      maxConnections = conn.getMetaData ().getMaxConnections ();
    /*
     * maxConnections == 0 ̏ꍇAڑɐȂsł̂ŁA
     * 0ȏ̏ꍇɍőڑ𒴂ĂȂm߂B
     * Ăꍇ́AxbZ[Wo
     */
    if (maxConnections > 0 && size >= maxConnections)
      println ("WARN! pool size will exceed safe max of " +
	       maxConnections);
    return conn;
  }
  /**
   * <P>ݒt@Cǂݍ݂܂Bݒt@C̐ڑv[Ɋւ
   * vpeBȊÕvpeB́AJDBCڑƂĎgp܂B
   * </P>
   *
   * <P>lw肷vpeBw肳ȂAȒlw肳
   * ꂽꍇ́AftHglgp܂B</P>
   *
   * @param name ݒt@CB
   *
   * @throws IOException w肳ꂽݒt@CȂAt@
   * C̓ǂݍ݂ɎsꍇB܂́Aݒt@CJDBChCo
   * AڑURLw肳ĂȂꍇB
   **/
  private synchronized static void loadProperties (String name)
  {
    ResourceBundle rb = ResourceBundle.getBundle (name);
    jdbcProperties = new Properties ();
    for (Enumeration en = rb.getKeys (); en.hasMoreElements ();)
      {
	String key = (String)en.nextElement ();
	if (key.equals ("driver"))
	  driverName = rb.getString (key);
	else if (key.equals ("protocol"))
	  protocol = rb.getString (key);
	else if (key.equals ("maxPoolSize"))
	  {
	    int n = getInteger (rb, key);
	    if (n > 0 || n == -1)
	      maxPoolSize = n;
	  }
	else if (key.equals ("maxUse"))
	  {
	    int n = getInteger (rb, key);
	    if (n > 0 || n == -1)
	      maxUse = n;
	  }
	else if (key.equals ("timeoutsec"))
	  {
	    int n = getInteger (rb, key);
	    if (n > 0 || n == -1)
	      timeout = n * 1000;
	  }
	else
	  {
	    String val = rb.getString (key);
	    jdbcProperties.setProperty (key, val);
	  }
      }
    if (driverName == null || driverName.equals (""))
      throw new IllegalArgumentException ("driverName property not found");
    if (protocol == null || protocol.equals (""))
      throw new IllegalArgumentException ("protocol property not found");
  }
  /**
   * <P>\[Xohw肳ꂽL[̒l𐮐ƂĎo܂B
   * </P>
   *
   * @param rb \[XohB
   * @param k L[B
   *
   * @return w肳ꂽL[ɑΉvpeBlBllȊO܂
   * L[Ȃꍇ -1 ԂB
   **/
  private static int getInteger (ResourceBundle rb, String k)
  {
    String s = rb.getString (k);
    try
      {
	return Integer.parseInt (s);
      }
    catch (NumberFormatException e)
      {
	throw new NumberFormatException (e.getMessage () +
					 "(property: " + k + ")");
      }
  }
  /**
   * <P>ݒt@Cǂݍ񂾃vpeB\܂B</P>
   **/
  public static void printProperties ()
  {
    println ("(property) driver: " + driverName);
    println ("(property) protocol: " + protocol);
    println ("(property) maxPoolSize: " + maxPoolSize + " connections");
    println ("(property) maxUse: " + maxUse + " times");
    println ("(property) timeout: " + timeout + " milli sec");
    for (Iterator iter = jdbcProperties.entrySet ().iterator ();
	 iter.hasNext (); )
      {
	Map.Entry ent = (Map.Entry)iter.next ();
	println ("(JDBC info) " + ent.getKey () + "=" + ent.getValue ());
      }
  }
  /* <P>fobOp */
  static void println (String s)
  {
    System.out.println ("ConnectionPoolDriver: " + s);
  }
}

/*
 * Local Variables: ***
 * compile-command: "(cd ../../; ant -emacs compile)" ***
 * End: ***
 */
